﻿Imports System.Text
Imports System.IO
Imports System.Data.SqlClient

Imports MongoDB.Bson
Imports MongoDB.Driver


Public Class TestFrm

    Private Structure Radnik
        'Public _id As String
        Public ID As String
        Public ime As String
        Public prezime As String
        Public status As String
        Public vozački As String
        Public komentar As String
        Public godišnji As String
        Public djece As String
        Public kontakt_telefon As String
        Public kontakt_email As String
    End Structure

    Private Sub btnKonfiguracija_Click(sender As Object, e As EventArgs) Handles btnKonfiguracija.Click
        MongoKonfiguracija()
    End Sub

    Private Sub btnProcitaj_Click(sender As Object, e As EventArgs) Handles btnProcitaj.Click
        MongoProcitaj()
    End Sub

    Private Sub btnDodaj_Click(sender As Object, e As EventArgs) Handles btnDodaj.Click
        MongoDodaj()
        MongoProcitaj()
    End Sub

    Private Sub btnObrisi_Click(sender As Object, e As EventArgs) Handles btnObrisi.Click
        MongoObrisi()
        MongoProcitaj()
    End Sub

    Private Sub btnSpremiSliku_Click(sender As Object, e As EventArgs)
        MongoKonfiguracija()
    End Sub

    Private Sub btnUcitajSliku_Click(sender As Object, e As EventArgs)

    End Sub

    Private Sub btnIzlaz_Click(sender As Object, e As EventArgs) Handles btnIzlaz.Click
        Me.Close()
    End Sub


    Private Sub MongoKonfiguracija()

        Dim client As New MongoClient()
        With client
            lstDocuments.Items.Clear()
            lstDocuments.Items.Add("Host: " + .Settings.Server.Host.ToString)
            lstDocuments.Items.Add("Port: " + .Settings.Server.Port.ToString)
            lstDocuments.Items.Add("Connection mode: " + .Settings.ConnectionMode.ToString)
            lstDocuments.Items.Add("Connection timeout: " + .Settings.ConnectTimeout.ToString)
        End With

    End Sub

    Private Sub MongoProcitaj()
        Dim filter = New BsonDocument("prezime", "Crnko")
        Dim sort = New BsonDocument("ID", -1)

        lstDocuments.Items.Clear()
        Dim client As New MongoClient()
        Try
            Dim db = client.GetDatabase("mongodbtest")
            Dim clist = db.GetCollection(Of BsonDocument)("radnik")

            'For Each item As BsonDocument In clist.Find(New BsonDocument(filter)).Sort(sort).ToList
            For Each item As BsonDocument In clist.Find(New BsonDocument()).ToList
                Dim r As New Radnik
                With r
                    r.ID = item.GetElement("ID").ToString
                    r.ime = item.GetElement("ime").ToString
                    r.prezime = item.GetElement("prezime").ToString

                    Try
                        r.djece = item.GetElement("djece").ToString
                    Catch
                        r.djece = "djece="
                    End Try

                    Try
                        r.vozački = item.GetElement("vozački").ToString
                    Catch
                        r.vozački = "vozački="
                    End Try

                    lstDocuments.Items.Add(r.ID + ", " + r.ime + ", " + r.prezime + ", " + r.djece + ", " + r.vozački)
                End With
            Next

            If lstDocuments.Items.Count > 0 Then
                btnObrisi.Visible = True
            Else
                btnObrisi.Visible = False
            End If

        Catch Ex As SystemException
            MsgBox(Ex.Message, MsgBoxStyle.Exclamation, Application.ProductName)
        End Try

    End Sub

    Private Sub MongoDodaj()

        Dim client As New MongoClient()
        Try
            Dim db = client.GetDatabase("mongodbtest")
            Dim clist = db.GetCollection(Of Radnik)("radnik")

            Dim r As New Radnik
            With r
                .ID = 2000 + Int(Rnd(1) * 1000)
                .ime = "testime" + id
                .prezime = "testprezime" + id
                .status = "neaktivan"
                .djece = Int(Rnd(1) * 8)
            End With

            clist.InsertOne(r)

        Catch ex As SystemException
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, Application.ProductName)
        End Try

    End Sub

    Private Sub MongoObrisi()
        Dim data() As String = Split(lstDocuments.Items(lstDocuments.SelectedIndex), ",")

        Dim ID As String = data(0).Replace("ID=", "")
        'ID = InputBox("Upišite ID radnika kojeg želite obrisati", "Brisanje podataka o radniku", ID, Me.Left + 10, Me.Top + 10)
        If ID <> "" Then
            Dim client As New MongoClient()
            Try
                Dim db = client.GetDatabase("mongodbtest")
                Dim clist = db.GetCollection(Of BsonDocument)("radnik")
                Dim filter = New BsonDocument("ID", ID)
                clist.FindOneAndDelete(filter)
            Catch Ex As SystemException
                MsgBox(Ex.Message, MsgBoxStyle.Exclamation, Application.ProductName)
            End Try
        End If
    End Sub


End Class