# download pymongo driver
# python -m pip install pymongo

import pymongo
import gridfs


def show_database(server):
    myclient = pymongo.MongoClient(server)
    dblist = myclient.list_database_names()

    print("Popis baza podataka na serveru " + server);
    print(dblist);
    


def show_collection(server, database, collection):
    myclient = pymongo.MongoClient(server)
    db = myclient[database]
    dblist = myclient.list_database_names()
    
    col = db.list_collection_names()
    print("Popis kolekcija u bazi podataka " + database);
    print(col)

    if collection in col:
        print("Kolekcija " + collection + " postoji u popisu kolekcija.")


       
def copy_data(server,database1,collection1,database2,collection2):

    myclient = pymongo.MongoClient(server)
    db1 = myclient[database1][collection1]
    db2 = myclient[database2][collection2]

    for a in db1.find():
        try:
            db2.insert_one(a)
            print(a)
        except:
            print('did not copy')



def show_data(server, database, collection):
    myclient = pymongo.MongoClient(server)
    col = myclient[database][collection]

    print("Pregled podataka u baza/kolekcija " + database + "/" + collection);
    for x in col.find({"prezime": "Crnko", "status": "Aktivan"},
                      { "_id": 0, "ime": 1, "prezime": 1, "status": 1 }).sort("ime", -1):
        print(x)



def mongo_gridfs1(server, database):
    myclient = pymongo.MongoClient(server)
    db = myclient[database]
    fs = gridfs.GridFS(db)
    saved = fs.put(b"Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.")
    print(saved)
    
    loaded = fs.get(saved).read()
    print(loaded)



def mongo_gridfs2(server, database):
    fobj = open("/tmp/Test.bmp", "rb")

    myclient = pymongo.MongoClient(server)
    db = myclient[database]
    fs = gridfs.GridFS(db)
    saved = fs.put(fobj)
    print(saved)
    fobj.close()       

    loaded = fs.get(saved).read()
    newfile = open("/tmp/Test2.bmp",'wb')
    newfile.write(loaded)
    newfile.close()



def main():
   show_database('mongodb://localhost:27017/')
   print("\n")
   show_collection('mongodb://localhost:27017/','mongodbtest','radnik')
   print("\n")
   show_collection('mongodb://localhost:27017/','mongodbnew','radnik')
   print("\n")
   copy_data('mongodb://localhost:27017/','mongodbtest','radnik','mongodbnew','penzioner')
   print("\n")
   show_collection('mongodb://localhost:27017/','mongodbnew','radnik')
   print("\n")
    
   show_data('mongodb://localhost:27017/','mongodbnew','penzioner')



    mongo_gridfs1('mongodb://localhost:27017/','mongodbtest')
    mongo_gridfs2('mongodb://localhost:27017/','mongodbtest')


main()
